export interface Options {
    /**
     * Alphabet to use for generating ids.
     */
    alphabet?: string;
}
export declare type ClassNameMap = {
    [longName: string]: string;
};
export declare class CssShortener {
    private _map;
    private generateId;
    constructor(options?: Options);
    get map(): ClassNameMap;
    /**
     * Imports mapped CSS class names
     * @param {object} map Map that should be imported
     * @param {boolean} override If true, existing mappings will be overridden
     */
    importMap(map: ClassNameMap, override?: boolean): void;
    /**
     * Checks if the given class name is already used as a replacement for a longer class name
     * @param className class name to check for
     */
    private isAlreadyUsed;
    /**
     * Generates and maps a new class name
     * @param className The existing class name that should be replaced
     * @returns {string} The new generated and mapped class name
     */
    shortenClassName(className: string): string;
}
